﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Semaforo1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            serialPort1.PortName = "COM6";
            serialPort1.BaudRate = 19200;
            serialPort1.Parity = System.IO.Ports.Parity.None;
            serialPort1.Open();
        }

        private void Form1_Load(object sender, EventArgs e)
        {


        
        }



        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {

            //chiude la porta quando si chiude il programma
            if (serialPort1.IsOpen)
            {
                serialPort1.Close();
            }
        }

        private void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {

            /*
       * convenzioni
       * la micro GT invia la seguente stringa:
       * 
       * @ C1 C2 C3 C4 INVIO
       * 
       * @ inizio stringa
       * 
       * C1 semaforo via belzoni (quello in via gottardo si comporta allo stesso modo)
       * possibili valori: 1 = verde	2 = arancione	3 = rosso
       * 
       * C2 semaforo via garibaldi (quello in via mazzini si comporta allo stesso modo)
       * possibili valori: 1 = verde	2 = arancione	3 = rosso
       * 
       * C3 semaforo pedonale via mazzini
       * possibili valori: 1= verde	3 = rosso
       * 
       * C4 semaforo pedonale via belzoni
       * possibili valori: 1= verde	3 = rosso
       * 
       * INVIO fine stringa
       */
            int belzoni = 0;
            int garibaldi = 0;
            int pedonale_mazzini = 0;
            int pedonale_belzoni = 0;
            int invio = 0;
            int situazione = 0;


            if (serialPort1.ReadByte() == '@') // sto ricevendo la stringa
            {

                belzoni = serialPort1.ReadByte();

                garibaldi = serialPort1.ReadByte();

                pedonale_mazzini = serialPort1.ReadByte();

                pedonale_belzoni = serialPort1.ReadByte();

                invio = serialPort1.ReadByte();	// fine ricezione stringa

                situazione = belzoni * 1000 + garibaldi * 100 + pedonale_mazzini * 10 + pedonale_belzoni;

                 if (situazione == 1333)
            {
                this.pictureBox1.Image = global::Semaforo1.Properties.Resources.Micro_GT_Semaforo_verde_belzoni___pedonali_mazzini_verde;
            }

            if (situazione == 2333)
            {
                this.pictureBox1.Image = global::Semaforo1.Properties.Resources.Micro_GT_Semaforo_giallo_belzoni___pedonali_rossi;
                //lblSemafori.setIcon(new ImageIcon("C:\\Users\\Massimo\\Documents\\WorkSpaceE\\Semafori\\src\\Micro-GT_Semaforo_giallo_belzoni - pedonali rossi.png"));
            }

            if (situazione == 3133)
            {
                this.pictureBox1.Image = global::Semaforo1.Properties.Resources.Micro_GT_Semaforo_verde_Garibaldi___pedonali_rossi;
                //lblSemafori.setIcon(new ImageIcon("C:\\Users\\Massimo\\Documents\\WorkSpaceE\\Semafori\\src\\Micro-GT_Semaforo_verde_Garibaldi - pedonali rossi.png"));
            }

            if (situazione == 3233)
            {
                this.pictureBox1.Image = global::Semaforo1.Properties.Resources.Micro_GT_Semaforo_giallo_Garibaldi___pedonali_rossi;
                //lblSemafori.setIcon(new ImageIcon("C:\\Users\\Massimo\\Documents\\WorkSpaceE\\Semafori\\src\\Micro-GT_Semaforo_giallo_Garibaldi - pedonali rossi.png"));
            }

            if (situazione == 1313)
            {
                this.pictureBox1.Image = global::Semaforo1.Properties.Resources.Micro_GT_Semaforo_verde_belzoni___pedonali_mazzini_verde;
                //lblSemafori.setIcon(new ImageIcon("C:\\Users\\Massimo\\Documents\\WorkSpaceE\\Semafori\\src\\Micro-GT_Semaforo_verde_belzoni - pedonali_mazzini_verde.png"));
            }

            if (situazione == 2313)
            {
                this.pictureBox1.Image = global::Semaforo1.Properties.Resources.Micro_GT_Semaforo_giallo_belzoni___pedonale_mazzini_verde;
                //lblSemafori.setIcon(new ImageIcon("C:\\Users\\Massimo\\Documents\\WorkSpaceE\\Semafori\\src\\Micro-GT_Semaforo_giallo_belzoni - pedonale_mazzini_verde.png"));
            }

            if (situazione == 3131)
            {
                this.pictureBox1.Image = global::Semaforo1.Properties.Resources.Micro_GT_Semaforo_verde_Garibaldi___pedonali_belzoni_verde;
                //lblSemafori.setIcon(new ImageIcon("C:\\Users\\Massimo\\Documents\\WorkSpaceE\\Semafori\\src\\Micro-GT_Semaforo_verde_Garibaldi - pedonali_belzoni_verde.png"));
            }

            if (situazione == 3231)
            {
                this.pictureBox1.Image = global::Semaforo1.Properties.Resources.Micro_GT_Semaforo_giallo_Garibaldi___pedonali_belzoni_verde;
                //lblSemafori.setIcon(new ImageIcon("C:\\Users\\Massimo\\Documents\\WorkSpaceE\\Semafori\\src\\Micro-GT_Semaforo_giallo_Garibaldi - pedonali_belzoni_verde.png"));
            }

            if (situazione == 3333)
            {
                this.pictureBox1.Image = global::Semaforo1.Properties.Resources.Micro_GT_Semaforo_tutti_rossi;
                //lblSemafori.setIcon(new ImageIcon("C:\\Users\\Massimo\\Documents\\WorkSpaceE\\Semafori\\src\\Micro-GT_Semaforo_tutti_rossi.png"));
            }
       // } // end modificaImmagine

            } // end if

            System.Console.WriteLine(situazione);
        }
   } 
               
        
}

